import React from 'react';
import { WithAsProps, FormControlBaseProps, RsRefForwardingComponent } from '../@types/common';
import { ValueType } from '../Checkbox';
export interface CheckboxGroupProps<V = ValueType[]> extends WithAsProps, FormControlBaseProps<V> {
    /** Used for the name of the form */
    name?: string;
    /** Primary content */
    children?: React.ReactNode;
    /** Inline layout */
    inline?: boolean;
}
export interface CheckboxGroupContextValue {
    inline?: boolean;
    name?: string;
    value?: ValueType[];
    controlled?: boolean;
    disabled?: boolean;
    readOnly?: boolean;
    plaintext?: boolean;
    onChange?: (value: any, checked: boolean, event: React.SyntheticEvent<HTMLInputElement>) => void;
}
export declare const CheckboxGroupContext: React.Context<CheckboxGroupContextValue>;
declare const CheckboxGroup: RsRefForwardingComponent<'div', CheckboxGroupProps>;
export default CheckboxGroup;
