"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = exports.CustomConsumer = exports.CustomContext = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _prefix = require("../utils/prefix");

var _DOMHelper = require("../DOMHelper");

var CustomContext = /*#__PURE__*/_react.default.createContext({});

exports.CustomContext = CustomContext;
var Consumer = CustomContext.Consumer,
    Provider = CustomContext.Provider;
exports.CustomConsumer = Consumer;
var themes = ['light', 'dark', 'high-contrast'];

var CustomProvider = function CustomProvider(props) {
  var children = props.children,
      _props$classPrefix = props.classPrefix,
      classPrefix = _props$classPrefix === void 0 ? (0, _prefix.getClassNamePrefix)() : _props$classPrefix,
      theme = props.theme,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["children", "classPrefix", "theme"]);

  var value = _react.default.useMemo(function () {
    return (0, _extends2.default)({
      classPrefix: classPrefix,
      theme: theme
    }, rest);
  }, [classPrefix, theme, rest]);

  _react.default.useEffect(function () {
    if (_DOMHelper.canUseDOM && theme) {
      (0, _DOMHelper.addClass)(document.body, (0, _prefix.prefix)(classPrefix, "theme-" + theme)); // Remove the className that will cause style conflicts

      themes.forEach(function (t) {
        if (t !== theme) {
          (0, _DOMHelper.removeClass)(document.body, (0, _prefix.prefix)(classPrefix, "theme-" + t));
        }
      });
    }
  }, [classPrefix, theme]);

  return /*#__PURE__*/_react.default.createElement(Provider, {
    value: value
  }, children);
};

var _default = CustomProvider;
exports.default = _default;