import React from 'react';
import { TableProps, ColumnProps, ColumnGroupProps } from 'rsuite-table';
import { StandardProps } from '../@types/common';
export interface TableInstance extends React.Component<TableProps> {
    scrollTop: (top: number) => void;
    scrollLeft: (left: number) => void;
}
export interface CellProps extends StandardProps {
    /** Data binding key, but also a sort of key */
    dataKey?: string;
    /** Row Number */
    rowIndex?: number;
    /** Row Data */
    rowData?: any;
}
interface TableComponent extends React.ForwardRefExoticComponent<TableProps & {
    ref?: React.Ref<TableInstance>;
}> {
    Column: React.ComponentType<ColumnProps>;
    ColumnGroup: React.ComponentType<ColumnGroupProps>;
    Cell: React.ComponentType<CellProps>;
    HeaderCell: React.ComponentType<StandardProps>;
}
declare const Table: TableComponent;
export default Table;
