import React from 'react';
import { InputPickerLocale } from '../locales';
import { PickerComponent } from '../Picker';
import { TagProps } from '../Tag';
import { ItemDataType, FormControlPickerProps } from '../@types/common';
import { SelectProps } from '../SelectPicker';
interface InputItemDataType extends ItemDataType {
    create?: boolean;
}
export declare type ValueType = any;
export interface InputPickerProps<T = ValueType> extends FormControlPickerProps<T, InputPickerLocale, InputItemDataType>, SelectProps<T> {
    tabIndex?: number;
    multi?: boolean;
    /** Settings can create new options */
    creatable?: boolean;
    /**  Tag related props. */
    tagProps?: TagProps;
    /** Option to cache value when searching asynchronously */
    cacheData?: InputItemDataType[];
    /** The `onBlur` attribute for the `input` element. */
    onBlur?: React.FocusEventHandler;
    /** The `onFocus` attribute for the `input` element. */
    onFocus?: React.FocusEventHandler;
    /** Called when the option is created */
    onCreate?: (value: ValueType, item: ItemDataType, event: React.SyntheticEvent) => void;
}
declare const InputPicker: PickerComponent<InputPickerProps>;
export default InputPicker;
