import _taggedTemplateLiteralLoose from "@babel/runtime/helpers/esm/taggedTemplateLiteralLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";

var _templateObject, _templateObject2, _templateObject3, _templateObject4;

import React, { useState, useRef, useEffect, useCallback } from 'react';
import PropTypes from 'prop-types';
import isUndefined from 'lodash/isUndefined';
import isNil from 'lodash/isNil';
import isFunction from 'lodash/isFunction';
import remove from 'lodash/remove';
import clone from 'lodash/clone';
import isArray from 'lodash/isArray';
import omit from 'lodash/omit';
import pick from 'lodash/pick';
import { getWidth } from 'dom-lib';
import shallowEqual from '../utils/shallowEqual';
import { filterNodesOfTree } from '../utils/treeUtils';
import Plaintext from '../Plaintext';
import { createChainedFunction, tplTransform, getDataGroupBy, useClassNames, useCustom, useControlled, mergeRefs } from '../utils';
import { DropdownMenu, DropdownMenuItem, DropdownMenuCheckItem, PickerToggle, PickerOverlay, PickerToggleTrigger, useFocusItemValue, usePickerClassName, useSearch, usePublicMethods, useToggleKeyDownEvent, pickTriggerPropKeys, omitTriggerPropKeys, listPickerPropTypes } from '../Picker';
import Tag from '../Tag';
import InputAutosize from './InputAutosize';
import InputSearch from './InputSearch';
var defaultProps = {
  as: 'div',
  appearance: 'default',
  cleanable: true,
  cacheData: [],
  classPrefix: 'picker',
  data: [],
  disabledItemValues: [],
  valueKey: 'value',
  labelKey: 'label',
  placement: 'bottomStart',
  searchable: true,
  menuAutoWidth: true,
  menuMaxHeight: 320,
  tagProps: {}
};
var InputPicker = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _merge;

  var Component = props.as,
      cleanable = props.cleanable,
      cacheData = props.cacheData,
      classPrefix = props.classPrefix,
      controlledData = props.data,
      disabled = props.disabled,
      readOnly = props.readOnly,
      plaintext = props.plaintext,
      defaultValue = props.defaultValue,
      defaultOpen = props.defaultOpen,
      disabledItemValues = props.disabledItemValues,
      overrideLocale = props.locale,
      toggleAs = props.toggleAs,
      style = props.style,
      searchable = props.searchable,
      multi = props.multi,
      controlledOpen = props.open,
      placeholder = props.placeholder,
      tagProps = props.tagProps,
      groupBy = props.groupBy,
      menuClassName = props.menuClassName,
      menuStyle = props.menuStyle,
      menuAutoWidth = props.menuAutoWidth,
      menuMaxHeight = props.menuMaxHeight,
      creatable = props.creatable,
      valueProp = props.value,
      valueKey = props.valueKey,
      virtualized = props.virtualized,
      labelKey = props.labelKey,
      listProps = props.listProps,
      id = props.id,
      tabIndex = props.tabIndex,
      sort = props.sort,
      renderMenu = props.renderMenu,
      renderExtraFooter = props.renderExtraFooter,
      renderValue = props.renderValue,
      renderMenuItem = props.renderMenuItem,
      renderMenuGroup = props.renderMenuGroup,
      onEnter = props.onEnter,
      onEntered = props.onEntered,
      onExit = props.onExit,
      onExited = props.onExited,
      onChange = props.onChange,
      onClean = props.onClean,
      onCreate = props.onCreate,
      onSearch = props.onSearch,
      onSelect = props.onSelect,
      onOpen = props.onOpen,
      onClose = props.onClose,
      onBlur = props.onBlur,
      onFocus = props.onFocus,
      searchBy = props.searchBy,
      placement = props.placement,
      rest = _objectWithoutPropertiesLoose(props, ["as", "cleanable", "cacheData", "classPrefix", "data", "disabled", "readOnly", "plaintext", "defaultValue", "defaultOpen", "disabledItemValues", "locale", "toggleAs", "style", "searchable", "multi", "open", "placeholder", "tagProps", "groupBy", "menuClassName", "menuStyle", "menuAutoWidth", "menuMaxHeight", "creatable", "value", "valueKey", "virtualized", "labelKey", "listProps", "id", "tabIndex", "sort", "renderMenu", "renderExtraFooter", "renderValue", "renderMenuItem", "renderMenuGroup", "onEnter", "onEntered", "onExit", "onExited", "onChange", "onClean", "onCreate", "onSearch", "onSelect", "onOpen", "onClose", "onBlur", "onFocus", "searchBy", "placement"]);

  if (groupBy === valueKey || groupBy === labelKey) {
    throw Error('`groupBy` can not be equal to `valueKey` and `labelKey`');
  }

  var overlayRef = useRef();
  var targetRef = useRef();
  var triggerRef = useRef();
  var inputRef = useRef();

  var _useCustom = useCustom(['Picker', 'InputPicker'], overrideLocale),
      locale = _useCustom.locale;

  var _useClassNames = useClassNames(classPrefix),
      prefix = _useClassNames.prefix,
      merge = _useClassNames.merge;

  var _useState = useState(controlledData),
      uncontrolledData = _useState[0],
      setData = _useState[1];

  var _useState2 = useState(100),
      maxWidth = _useState2[0],
      setMaxWidth = _useState2[1];

  var _useState3 = useState([]),
      newData = _useState3[0],
      setNewData = _useState3[1];

  var _useState4 = useState(defaultOpen),
      uncontrolledOpen = _useState4[0],
      setOpen = _useState4[1];

  var open = isUndefined(controlledOpen) ? uncontrolledOpen : controlledOpen;
  var getAllData = useCallback(function () {
    return [].concat(uncontrolledData, newData);
  }, [uncontrolledData, newData]);
  var getAllDataAndCache = useCallback(function () {
    return [].concat(getAllData(), cacheData);
  }, [getAllData, cacheData]);

  var _useControlled = useControlled(valueProp, multi ? defaultValue || [] : defaultValue),
      value = _useControlled[0],
      setValue = _useControlled[1],
      isControlled = _useControlled[2];

  var cloneValue = useCallback(function () {
    return multi ? clone(value) || [] : value;
  }, [multi, value]);
  var handleClose = useCallback(function () {
    var _triggerRef$current;

    triggerRef === null || triggerRef === void 0 ? void 0 : (_triggerRef$current = triggerRef.current) === null || _triggerRef$current === void 0 ? void 0 : _triggerRef$current.close();
  }, [triggerRef]); // Used to hover the focuse item  when trigger `onKeydown`

  var _useFocusItemValue = useFocusItemValue(multi ? value === null || value === void 0 ? void 0 : value[0] : value, {
    data: getAllDataAndCache(),
    valueKey: valueKey,
    target: function target() {
      return overlayRef.current;
    }
  }),
      focusItemValue = _useFocusItemValue.focusItemValue,
      setFocusItemValue = _useFocusItemValue.setFocusItemValue,
      onKeyDown = _useFocusItemValue.onKeyDown;

  var handleSearchCallback = useCallback(function (searchKeyword, filteredData, event) {
    var _filteredData$;

    // The first option after filtering is the focus.
    setFocusItemValue((filteredData === null || filteredData === void 0 ? void 0 : (_filteredData$ = filteredData[0]) === null || _filteredData$ === void 0 ? void 0 : _filteredData$[valueKey]) || searchKeyword);
    onSearch === null || onSearch === void 0 ? void 0 : onSearch(searchKeyword, event);
  }, [setFocusItemValue, onSearch, valueKey]); // Use search keywords to filter options.

  var _useSearch = useSearch({
    labelKey: labelKey,
    data: getAllData(),
    searchBy: searchBy,
    callback: handleSearchCallback
  }),
      searchKeyword = _useSearch.searchKeyword,
      setSearchKeyword = _useSearch.setSearchKeyword,
      checkShouldDisplay = _useSearch.checkShouldDisplay,
      handleSearch = _useSearch.handleSearch; // Update the state when the data in props changes


  useEffect(function () {
    if (controlledData && !shallowEqual(controlledData, uncontrolledData)) {
      var _controlledData$;

      setData(controlledData);
      setNewData([]);
      setFocusItemValue(controlledData === null || controlledData === void 0 ? void 0 : (_controlledData$ = controlledData[0]) === null || _controlledData$ === void 0 ? void 0 : _controlledData$[valueKey]);
    }
  }, [setFocusItemValue, controlledData, uncontrolledData, valueKey]);
  useEffect(function () {
    var _triggerRef$current2;

    // In multiple selection, you need to set a maximum width for the input.
    if ((_triggerRef$current2 = triggerRef.current) !== null && _triggerRef$current2 !== void 0 && _triggerRef$current2.root) {
      setMaxWidth(getWidth(triggerRef.current.root));
    }
  }, []); // Update the position of the menu when the search keyword and value change

  useEffect(function () {
    var _triggerRef$current3, _triggerRef$current3$;

    (_triggerRef$current3 = triggerRef.current) === null || _triggerRef$current3 === void 0 ? void 0 : (_triggerRef$current3$ = _triggerRef$current3.updatePosition) === null || _triggerRef$current3$ === void 0 ? void 0 : _triggerRef$current3$.call(_triggerRef$current3);
  }, [searchKeyword, value]);

  var getDateItem = function getDateItem(value) {
    // Find active `MenuItem` by `value`
    var allData = getAllDataAndCache();
    var activeItem = allData.find(function (item) {
      return shallowEqual(item[valueKey], value);
    });
    var displayElement = placeholder;

    if (activeItem !== null && activeItem !== void 0 && activeItem[labelKey]) {
      displayElement = activeItem === null || activeItem === void 0 ? void 0 : activeItem[labelKey];
    }

    return {
      isValid: !!activeItem,
      activeItem: activeItem,
      displayElement: displayElement
    };
  };

  var getInput = useCallback(function () {
    var _inputRef$current;

    return multi ? (_inputRef$current = inputRef.current) === null || _inputRef$current === void 0 ? void 0 : _inputRef$current.input : inputRef.current;
  }, [inputRef, multi]);
  var focusInput = useCallback(function () {
    var _getInput;

    return (_getInput = getInput()) === null || _getInput === void 0 ? void 0 : _getInput.focus();
  }, [getInput]);
  var blurInput = useCallback(function () {
    var _getInput2;

    return (_getInput2 = getInput()) === null || _getInput2 === void 0 ? void 0 : _getInput2.blur();
  }, [getInput]);
  /**
   * Convert the string of the newly created option into an object.
   */

  var createOption = useCallback(function (value) {
    var _ref2;

    if (groupBy) {
      var _ref;

      return _ref = {
        create: true
      }, _ref[groupBy] = locale === null || locale === void 0 ? void 0 : locale.newItem, _ref[valueKey] = value, _ref[labelKey] = value, _ref;
    }

    return _ref2 = {
      create: true
    }, _ref2[valueKey] = value, _ref2[labelKey] = value, _ref2;
  }, [groupBy, valueKey, labelKey, locale]);
  var handleChange = useCallback(function (value, event) {
    onChange === null || onChange === void 0 ? void 0 : onChange(value, event);
  }, [onChange]);
  var handleRemoveItemByTag = useCallback(function (tag, event) {
    event.stopPropagation();
    var val = cloneValue();
    remove(val, function (itemVal) {
      return shallowEqual(itemVal, tag);
    });
    setValue(val);
    handleChange(val, event);
  }, [setValue, cloneValue, handleChange]);
  var handleSelect = useCallback(function (value, item, event) {
    onSelect === null || onSelect === void 0 ? void 0 : onSelect(value, item, event);

    if (creatable && item.create) {
      delete item.create;
      onCreate === null || onCreate === void 0 ? void 0 : onCreate(value, item, event);
      setNewData(newData.concat(item));
    }
  }, [creatable, newData, onSelect, onCreate]);
  /**
   * Callback triggered by single selection
   * @param value
   * @param item
   * @param event
   */

  var handleItemSelect = function handleItemSelect(value, item, event) {
    setValue(value);
    setFocusItemValue(value);
    setSearchKeyword('');
    handleSelect(value, item, event);
    handleChange(value, event);
    handleClose();
  };
  /**
   * Callback triggered by multiple selection
   * @param nextItemValue
   * @param item
   * @param event
   * @param checked
   */


  var handleCheckItemSelect = function handleCheckItemSelect(nextItemValue, item, event, checked) {
    var val = cloneValue();

    if (checked) {
      val.push(nextItemValue);
    } else {
      remove(val, function (itemVal) {
        return shallowEqual(itemVal, nextItemValue);
      });
    }

    setValue(val);
    setSearchKeyword('');
    setFocusItemValue(nextItemValue);
    handleSelect(val, item, event);
    handleChange(val, event);
    focusInput();
  };

  var selectFocusMenuCheckItem = useCallback(function (event) {
    var val = cloneValue();
    var data = getAllData();

    if (!focusItemValue || !data) {
      return;
    } // If the value is disabled in this option, it is returned.


    if (disabledItemValues !== null && disabledItemValues !== void 0 && disabledItemValues.some(function (item) {
      return item === focusItemValue;
    })) {
      return;
    }

    if (!val.some(function (v) {
      return shallowEqual(v, focusItemValue);
    })) {
      val.push(focusItemValue);
    } else {
      remove(val, function (itemVal) {
        return shallowEqual(itemVal, focusItemValue);
      });
    }

    var focusItem = data.find(function (item) {
      return shallowEqual(item === null || item === void 0 ? void 0 : item[valueKey], focusItemValue);
    });

    if (!focusItem) {
      focusItem = createOption(focusItemValue);
    }

    setValue(val);
    setSearchKeyword('');
    handleSelect(val, focusItem, event);
    handleChange(val, event);
  }, [setValue, cloneValue, getAllData, handleChange, handleSelect, createOption, setSearchKeyword, disabledItemValues, focusItemValue, valueKey]);
  var selectFocusMenuItem = useCallback(function (event) {
    if (!focusItemValue || !controlledData) {
      return;
    } // If the value is disabled in this option, it is returned.


    if (disabledItemValues !== null && disabledItemValues !== void 0 && disabledItemValues.some(function (item) {
      return item === focusItemValue;
    })) {
      return;
    } // Find active `MenuItem` by `value`


    var allData = getAllData();
    var focusItem = allData.find(function (item) {
      return shallowEqual(item[valueKey], focusItemValue);
    });

    if (!focusItem && focusItemValue === searchKeyword) {
      focusItem = createOption(searchKeyword);
    }

    setValue(focusItemValue);
    setSearchKeyword('');
    handleSelect(focusItemValue, focusItem, event);
    handleChange(focusItemValue, event);
    handleClose();
  }, [setValue, disabledItemValues, controlledData, focusItemValue, valueKey, searchKeyword, handleClose, setSearchKeyword, createOption, getAllData, handleChange, handleSelect]);
  usePublicMethods(ref, {
    triggerRef: triggerRef,
    overlayRef: overlayRef,
    targetRef: targetRef
  });
  /**
   * Remove the last item, after pressing the back key on the keyboard.
   * @param event
   */

  var removeLastItem = useCallback(function (event) {
    var target = event === null || event === void 0 ? void 0 : event.target;

    if ((target === null || target === void 0 ? void 0 : target.tagName) !== 'INPUT') {
      focusInput();
      return;
    }

    if ((target === null || target === void 0 ? void 0 : target.tagName) === 'INPUT' && target !== null && target !== void 0 && target.value) {
      return;
    }

    var val = cloneValue();
    val.pop();
    setValue(val);
    handleChange(val, event);
  }, [setValue, focusInput, handleChange, cloneValue]);
  var handleClean = useCallback(function (event) {
    if (disabled || searchKeyword !== '') {
      return;
    }

    setValue(null);
    setFocusItemValue(null);
    setSearchKeyword('');
    handleChange(null, event);
    onClean === null || onClean === void 0 ? void 0 : onClean(event);
  }, [disabled, searchKeyword, onClean, handleChange, setValue, setFocusItemValue, setSearchKeyword]);
  var onPickerKeyDown = useToggleKeyDownEvent(_extends({
    triggerRef: triggerRef,
    targetRef: targetRef,
    overlayRef: overlayRef,
    onMenuPressEnter: multi ? selectFocusMenuCheckItem : selectFocusMenuItem,
    onMenuPressBackspace: multi ? removeLastItem : handleClean,
    onMenuKeyDown: onKeyDown
  }, rest));
  var handleExited = useCallback(function () {
    setFocusItemValue(multi ? value === null || value === void 0 ? void 0 : value[0] : value);
    setSearchKeyword('');
    onClose === null || onClose === void 0 ? void 0 : onClose();
  }, [setFocusItemValue, setSearchKeyword, onClose, value, multi]);
  var handleFocus = useCallback(function () {
    if (!readOnly) {
      var _triggerRef$current4;

      setOpen(true);
      (_triggerRef$current4 = triggerRef.current) === null || _triggerRef$current4 === void 0 ? void 0 : _triggerRef$current4.open();
    }
  }, [readOnly]);
  var handleBlur = useCallback(function () {
    setOpen(false);
  }, []);
  var handleEnter = useCallback(function () {
    focusInput();
    setOpen(true);
  }, [focusInput]);
  var handleExit = useCallback(function () {
    blurInput();
    setOpen(false);
  }, [blurInput]);

  var renderDropdownMenuItem = function renderDropdownMenuItem(label, item) {
    // 'Create option "{0}"' =>  Create option "xxxxx"
    var newLabel = item.create ? /*#__PURE__*/React.createElement("span", null, tplTransform(locale === null || locale === void 0 ? void 0 : locale.createOption, label)) : label;
    return renderMenuItem ? renderMenuItem(newLabel, item) : newLabel;
  };

  var renderSingleValue = function renderSingleValue() {
    if (multi) {
      return {
        isValid: false,
        displayElement: placeholder
      };
    }

    var dataItem = getDateItem(value);
    var displayElement = dataItem.displayElement;

    if (!isNil(value) && isFunction(renderValue)) {
      displayElement = renderValue(value, dataItem.activeItem, displayElement);
    }

    return {
      isValid: dataItem.isValid,
      displayElement: displayElement
    };
  };

  var renderMultiValue = function renderMultiValue() {
    if (!multi) {
      return null;
    }

    var _tagProps$closable = tagProps.closable,
        closable = _tagProps$closable === void 0 ? true : _tagProps$closable,
        onClose = tagProps.onClose,
        tagRest = _objectWithoutPropertiesLoose(tagProps, ["closable", "onClose"]);

    var tags = value || [];
    var items = [];
    var tagElements = tags.map(function (tag) {
      var _getDateItem = getDateItem(tag),
          isValid = _getDateItem.isValid,
          displayElement = _getDateItem.displayElement,
          activeItem = _getDateItem.activeItem;

      items.push(activeItem);

      if (!isValid) {
        return null;
      }

      return /*#__PURE__*/React.createElement(Tag, _extends({}, tagRest, {
        key: tag,
        size: rest.size === 'lg' ? 'lg' : rest.size === 'xs' ? 'sm' : 'md',
        closable: !disabled && closable && !readOnly && !plaintext,
        title: typeof displayElement === 'string' ? displayElement : undefined,
        onClose: createChainedFunction(handleRemoveItemByTag.bind(null, tag), onClose)
      }), displayElement);
    }).filter(function (item) {
      return item !== null;
    });

    if ((tags.length > 0 || isControlled) && isFunction(renderValue)) {
      return renderValue(value, items, tagElements);
    }

    return tagElements;
  };

  var renderDropdownMenu = function renderDropdownMenu(positionProps, speakerRef) {
    var left = positionProps.left,
        top = positionProps.top,
        className = positionProps.className;
    var menuClassPrefix = multi ? 'picker-check-menu' : 'picker-select-menu';
    var classes = merge(className, menuClassName, prefix(menuClassPrefix));

    var styles = _extends({}, menuStyle, {
      left: left,
      top: top
    });

    var items = filterNodesOfTree(getAllData(), checkShouldDisplay);

    if (creatable && searchKeyword && !items.find(function (item) {
      return item[valueKey] === searchKeyword;
    })) {
      items = [].concat(items, [createOption(searchKeyword)]);
    } // Create a tree structure data when set `groupBy`


    if (groupBy) {
      items = getDataGroupBy(items, groupBy, sort);
    } else if (typeof sort === 'function') {
      items = items.sort(sort(false));
    }

    var menu = items.length ? /*#__PURE__*/React.createElement(DropdownMenu, {
      id: id ? id + "-listbox" : undefined,
      listProps: listProps,
      disabledItemValues: disabledItemValues,
      valueKey: valueKey,
      labelKey: labelKey,
      classPrefix: menuClassPrefix,
      dropdownMenuItemClassPrefix: multi ? undefined : menuClassPrefix + "-item",
      dropdownMenuItemAs: multi ? DropdownMenuCheckItem : DropdownMenuItem,
      activeItemValues: multi ? value : [value],
      focusItemValue: focusItemValue,
      maxHeight: menuMaxHeight,
      data: items,
      group: !isUndefined(groupBy),
      onSelect: multi ? handleCheckItemSelect : handleItemSelect,
      renderMenuGroup: renderMenuGroup,
      renderMenuItem: renderDropdownMenuItem,
      virtualized: virtualized
    }) : /*#__PURE__*/React.createElement("div", {
      className: prefix(_templateObject || (_templateObject = _taggedTemplateLiteralLoose(["none"])))
    }, locale === null || locale === void 0 ? void 0 : locale.noResultsText);
    return /*#__PURE__*/React.createElement(PickerOverlay, {
      ref: mergeRefs(overlayRef, speakerRef),
      autoWidth: menuAutoWidth,
      className: classes,
      style: styles,
      target: triggerRef,
      onKeyDown: onPickerKeyDown
    }, renderMenu ? renderMenu(menu) : menu, renderExtraFooter === null || renderExtraFooter === void 0 ? void 0 : renderExtraFooter());
  };

  var _renderSingleValue = renderSingleValue(),
      isValid = _renderSingleValue.isValid,
      displayElement = _renderSingleValue.displayElement;

  var tagElements = renderMultiValue();
  /**
   * 1.Have a value and the value is valid.
   * 2.Regardless of whether the value is valid, as long as renderValue is set, it is judged to have a value.
   * 3.If renderValue returns null or undefined, hasValue is false.
   */

  var hasSingleValue = !isNil(value) && isFunction(renderValue) && !isNil(displayElement);
  var hasMultiValue = isArray(value) && value.length > 0 && isFunction(renderValue) && !isNil(tagElements);
  var hasValue = multi ? !!(tagElements !== null && tagElements !== void 0 && tagElements.length) || hasMultiValue : isValid || hasSingleValue;

  var _usePickerClassName = usePickerClassName(_extends({}, props, {
    hasValue: hasValue,
    name: 'input'
  })),
      pickerClasses = _usePickerClassName[0],
      usedClassNamePropKeys = _usePickerClassName[1];

  var classes = merge(pickerClasses, (_merge = {}, _merge[prefix(_templateObject2 || (_templateObject2 = _taggedTemplateLiteralLoose(["tag"])))] = multi, _merge[prefix(_templateObject3 || (_templateObject3 = _taggedTemplateLiteralLoose(["focused"])))] = open, _merge));
  var searching = !!searchKeyword && open;
  var displaySearchInput = searchable && !disabled;
  var inputProps = multi ? {
    inputStyle: {
      maxWidth: maxWidth - 63
    },
    as: InputAutosize
  } : {
    as: 'input'
  };

  if (plaintext) {
    var plaintextProps = {}; // TagPicker has -6px margin-left on the plaintext wrapper
    // for fixing margin-left on tags from 2nd line on

    if (multi) {
      plaintextProps.style = {
        marginLeft: -6
      };
    }

    return /*#__PURE__*/React.createElement(Plaintext, _extends({
      localeKey: "notSelected",
      ref: targetRef
    }, plaintextProps), displayElement || (tagElements !== null && tagElements !== void 0 && tagElements.length ? tagElements : null));
  }

  return /*#__PURE__*/React.createElement(PickerToggleTrigger, {
    pickerProps: pick(props, pickTriggerPropKeys),
    ref: triggerRef,
    trigger: "active",
    onEnter: createChainedFunction(handleEnter, onEnter),
    onEntered: createChainedFunction(onEntered, onOpen),
    onExit: createChainedFunction(handleExit, onExit),
    onExited: createChainedFunction(handleExited, onExited),
    speaker: renderDropdownMenu,
    placement: placement
  }, /*#__PURE__*/React.createElement(Component, {
    className: classes,
    style: style,
    onClick: focusInput,
    onKeyDown: onPickerKeyDown
  }, /*#__PURE__*/React.createElement(PickerToggle, _extends({}, omit(rest, [].concat(omitTriggerPropKeys, usedClassNamePropKeys)), {
    id: id,
    readOnly: readOnly,
    plaintext: plaintext,
    ref: targetRef,
    as: toggleAs,
    tabIndex: null,
    onClean: handleClean,
    cleanable: cleanable && !disabled,
    hasValue: hasValue,
    active: open,
    disabled: disabled,
    placement: placement,
    inputValue: value
  }), searching || multi && hasValue ? null : displayElement || (locale === null || locale === void 0 ? void 0 : locale.placeholder)), !(!multi && disabled) && /*#__PURE__*/React.createElement("div", {
    className: prefix(_templateObject4 || (_templateObject4 = _taggedTemplateLiteralLoose(["tag-wrapper"])))
  }, tagElements, displaySearchInput && /*#__PURE__*/React.createElement(InputSearch, _extends({}, inputProps, {
    tabIndex: tabIndex,
    readOnly: readOnly,
    onBlur: createChainedFunction(handleBlur, onBlur),
    onFocus: createChainedFunction(handleFocus, onFocus),
    inputRef: inputRef,
    onChange: handleSearch,
    value: open ? searchKeyword : ''
  })))));
});
InputPicker.displayName = 'InputPicker';
InputPicker.defaultProps = defaultProps;
InputPicker.propTypes = _extends({}, listPickerPropTypes, {
  locale: PropTypes.any,
  appearance: PropTypes.oneOf(['default', 'subtle']),
  cacheData: PropTypes.array,
  menuAutoWidth: PropTypes.bool,
  menuMaxHeight: PropTypes.number,
  searchable: PropTypes.bool,
  creatable: PropTypes.bool,
  multi: PropTypes.bool,
  groupBy: PropTypes.any,
  sort: PropTypes.func,
  renderMenu: PropTypes.func,
  renderMenuItem: PropTypes.func,
  renderMenuGroup: PropTypes.func,
  onCreate: PropTypes.func,
  onSelect: PropTypes.func,
  onGroupTitleClick: PropTypes.func,
  onSearch: PropTypes.func,
  virtualized: PropTypes.bool,
  searchBy: PropTypes.func,
  tagProps: PropTypes.object
});
export default InputPicker;