import React from 'react';
import { WithAsProps, TypeAttributes } from '../@types/common';
import { ToggleLocale } from '../locales';
export interface ToggleProps extends WithAsProps {
    /** Wheather to disabled toggle */
    disabled?: boolean;
    /** Render the control as plain text */
    plaintext?: boolean;
    /** Make the control readonly */
    readOnly?: boolean;
    /** Checked（Controlled) */
    checked?: boolean;
    /** Default checked */
    defaultChecked?: boolean;
    /** Checked display content */
    checkedChildren?: React.ReactNode;
    /** Unselected display content */
    unCheckedChildren?: React.ReactNode;
    /** Toggle size */
    size?: Omit<TypeAttributes.Size, 'xs'>;
    /** Custom locale */
    locale?: ToggleLocale;
    /** Callback function when state changes */
    onChange?: (checked: boolean, event: React.SyntheticEvent) => void;
}
/**
 * fixme: Should contain an input[type=checkbox]
 */
declare const Toggle: React.ForwardRefExoticComponent<ToggleProps & React.RefAttributes<unknown>>;
export default Toggle;
